-- | A module that represents that access levels available to @scaladoc@.
module Lastik.Scala.Access(
                           Access(..)
                          ) where

-- | Show only public, protected/public (default) or all classes and members (public,protected,private)
data Access = Public      -- ^ @public@
              | Protected -- ^ @protected@
              | Private   -- ^ @private@
              deriving Eq

instance Show Access where
  show Public = "public"
  show Protected = "protected"
  show Private = "private"
