-- | A module that represents the debug levels to @scalac@ and @scaladoc@.
module Lastik.Scala.Debug(
                          Debug(..)
                         )where

-- | Specify level of generated debugging info (none,source,line,vars,notailcalls)
data Debug = None          -- ^ @none@
             | Source      -- ^ @source@
             | Line        -- ^ @line@
             | Vars        -- ^ @vars@
             | NoTailCalls -- ^ @notailcalls@
             deriving Eq

instance Show Debug where
  show None = "none"
  show Source = "source"
  show Line = "line"
  show Vars = "vars"
  show NoTailCalls = "notailcalls"
